import { defineMultiplexingMode } from './codemirror-my-multiplex';
import { defineFinesse2Mode } from './codemirror-finesse2';

export function setupFinesseCodeMirror(CodeMirror: any): void {
  defineMultiplexingMode(CodeMirror);
  defineFinesse2Mode(CodeMirror);

  CodeMirror.defineMode('finesse-python', (config: any) => {
    const pmode = CodeMirror.getMode(config, 'python');
    return CodeMirror.myMultiplexingMode(pmode, {
      open: /(?=#kat2code)/,
      close: /(?=""")/, // Match string end without consuming it
      mode: CodeMirror.getMode(config, 'text/x-finesse2'),
      delimStyle: 'delim'
    });
  });

  CodeMirror.defineMIME('text/x-finesse-python', 'finesse-python');

  CodeMirror.modeInfo.push({
    name: 'Finesse Python',
    mime: 'text/x-finesse-python',
    mode: 'finesse-python',
    ext: []
  });
}
